config/routes.rb
Rails.application.routes.draw do
  resources :movies
  get '/', to: 'movies#index'

  # get '/salut/:name', to: 'pages#salut'
  #resources :index
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/director.rb
class Director < ApplicationRecord
  has_many :movies
end

app/models/movie.rb
class Movie < ApplicationRecord
  belongs_to :directors
end

app/controllers/.movies_controller_controller.rb
class MoviesControllerController < ApplicationController
  
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/movies_controller.rb
class MoviesController < ApplicationController
  before_action :set_movie, only: [:show, :edit, :update, :destroy]

  # GET /movies
  # GET /movies.json
  def index
    @movies = Movie.all
  end

  # GET /movies/1
  # GET /movies/1.json
  def show
  end

  # GET /movies/new
  def new
    @movie = Movie.new
  end

  # GET /movies/1/edit
  def edit
  end
  def index
    @movies = []
    @movies= Movie.all
  end
  # POST /movies
  # POST /movies.json
  def create
    @movie = Movie.new(movie_params)

    respond_to do |format|
      if @movie.save
        format.html { redirect_to @movie, notice: 'Movie was successfully created.' }
        format.json { render :show, status: :created, location: @movie }
      else
        format.html { render :new }
        format.json { render json: @movie.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /movies/1
  # PATCH/PUT /movies/1.json
  def update
    respond_to do |format|
      if @movie.update(movie_params)
        format.html { redirect_to @movie, notice: 'Movie was successfully updated.' }
        format.json { render :show, status: :ok, location: @movie }
      else
        format.html { render :edit }
        format.json { render json: @movie.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /movies/1
  # DELETE /movies/1.json
  def destroy
    @movie.destroy
    respond_to do |format|
      format.html { redirect_to movies_url, notice: 'Movie was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
  # Use callbacks to share common setup or constraints between actions.
  def set_movie
    @movie = Movie.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def movie_params
    params.require(:movie).permit(:title, :release_year, :director)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/movies_controller_helper.rb
module MoviesControllerHelper
end

app/helpers/movies_helper.rb
module MoviesHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>TheMovieDatabase2</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/movies/_form.html.erb
<%= form_with(model: movie, local: true) do |form| %>
  <% if movie.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(movie.errors.count, "error") %> prohibited this movie from being saved:</h2>

      <ul>
      <% movie.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :title %>
    <%= form.text_field :title %>
  </div>

  <div class="field">
    <%= form.label :release_year %>
    <%= form.number_field :release_year %>
  </div>

  <div class="field">
    <%= form.label :director %>
    <%= form.text_field :director %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/movies/edit.html.erb
<h1>Editing Movie</h1>

<%= render 'form', movie: @movie %>

<%= link_to 'Show', @movie %> |
<%= link_to 'Back', movies_path %>

app/views/movies/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Movies</h1>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Release year</th>
      <th>Director</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @movies.each do |movie| %>
      <tr>
        <td><%= movie.title %></td>
        <td><%= movie.release_year %></td>
        <td><%= movie.director %></td>
        <td><%= link_to 'Show', movie %></td>
        <td><%= link_to 'Edit', edit_movie_path(movie) %></td>
        <td><%= link_to 'Destroy', movie, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Movie', new_movie_path %>

app/views/movies/new.html.erb
<h1>New Movie</h1>

<%= render 'form', movie: @movie %>

<%= link_to 'Back', movies_path %>

app/views/movies/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Title:</strong>
  <%= @movie.title %>
</p>

<p>
  <strong>Release year:</strong>
  <%= @movie.release_year %>
</p>

<p>
  <strong>Director:</strong>
  <%= @movie.director %>
</p>

<%= link_to 'Edit', edit_movie_path(@movie) %> |
<%= link_to 'Back', movies_path %>